#include <avr/io.h>
#include <avr/fuse.h>
#include <avr/signature.h>
#include <avr/interrupt.h>
#include <avr/sleep.h>

#include "usbhost.h"

FUSES = {
 0xE1,	// HF PLL => 16 MHz
 0xD5,	// Brown-Out 2,7 V
 0xFF	// keine Selbstprogramierung
};

UsbHost usbhost0, usbhost1;

void UsbHost::init() {
}

__attribute__((OS_main)) int main() {
 ACSR|=1<<ACD;
 TCCR0B = 0x04;		// Vorteiler 256
 TIMSK = 1<<OCIE0A;	// ISR kümmert sich um 1-ms-Takt
 MCUCR = 0x20;		// Idle beim Schlafen
 UsbHost::init();
 sei();
 for(;;) {
  if (GPIOR0&1<<4) {
   UsbHost::sof();
   usbhost0.poll();
//   usbhost1.poll();
  }
  sleep_cpu();
 }
}
