; usbconv for AT90S2313  Ver 1.0  2005.03.10 by K.Ishikawa
#define __SFR_OFFSET 0
#include <avr/io.h>

;------------------------------------------------------------------------------
;	AVR Port Assign List
;
;	PortB bit0  LED
;	      bit1  Select 0: Mouse 1:Keyboard 
;	      bit2  Select Baudrate
;	      bit3  Select Baudrate
;	      bit4  Select Baudrate
;	      bit5  ISP MOSI
;	      bit6  ISP MISO
;	      bit7  ISP SCK
;	PortD bit0  RxD
;	      bit1  TxD
;	      bit2  USB BUS D+
;	      bit3  USB BUS D-
;	      bit4  
;	      bit5  
;	      bit6  

;------------------------------------------------------------------------------

// r1 = __zero_reg__
// r2 and r3 reserved for ISR
#define	uartwi	r8
#define	uartri	r9
#define	tcount	r10	// up-counter in 1 ms steps
#define	keysts	r15
#define	keynum_n	r16
#define	keynum		r17
#define	icount		r19
#define	connect		r20
#define	tmp1	r22
#define	tmp2	r23
// wie XL, XH usw., Argument wie in avr-gcc
#define	WL	r24
#define	WH	r25

.data
UARTBUF:	.byte	8	; UART Tx buffer
USBBUFSTART:	.byte	100	; USB receive buffer
#define INTERVAL 24	// Query interrupt pipe inverval, in ms
// Normally dictated by Endpoint Descriptor.
.text
;------------------------------------------------------------------------------
.macro ldix v
	ldi	XH,hi8(\v)
	ldi	XL,lo8(\v)
.endm
.macro ldiy v
	ldi	YH,hi8(\v)
	ldi	YL,lo8(\v)
.endm
.macro ldiz v
	ldi	ZH,hi8(\v)
	ldi	ZL,lo8(\v)
.endm

;------------------------------------------------------------------------------

	rjmp	main	; Reset Handler
	nop		; here: INT0 Handler
	nop		; here: INT1 Handler
	nop		; here: Timer1 Capture Handler
	nop		; here: Timer1 Compare Handler
	nop		; here: Timer1 Overflow Handler
	in	r2,SREG		; Timer0 Overflow Handler
	inc	tcount		; here: UART RX Complete Handler
	out	SREG,r2		; here: UDR Empty Handler
	out	TCNT0,r3	; here: UART TX Complete Handler
	reti		; here: Analog Comparator Handler

;------------------------------------------------------------------------------
// Nicht disassemblieren
.type DATA_PKT_ACK,@common
DATA_PKT_ACK:
	.byte	0x04, 0x08, 0x04, 0x08, 0x04, 0x08, 0x04, 0x04
	.byte	0x08, 0x08, 0x04, 0x08, 0x08, 0x04, 0x04, 0x04
.type DATA_EOP,@common
DATA_EOP:
	.byte	0x02, 0x02, 0x08, 0x08				// 00JJ
.type DATA_PKT_SETUP_TOKEN_0,@common
DATA_PKT_SETUP_TOKEN_0:
	.byte	0x04, 0x08, 0x04, 0x08, 0x04, 0x08, 0x04, 0x04	// KJKJKJKK 00000001
	.byte	0x04, 0x08, 0x08, 0x08, 0x04, 0x04, 0x08, 0x04	// KJJJKKJK 10110100 SETUP
	.byte	0x08, 0x04, 0x08, 0x04, 0x08, 0x04, 0x08, 0x04	// JKJKJKJK 00000000
	.byte	0x08, 0x04, 0x08, 0x04, 0x04, 0x08, 0x04, 0x08	// JKJKKJKJ 00001000 CRC16
	.byte	0x02, 0x02, 0x08, 0x08				// EOP
.type DATA_PKT_SET_ADDRESS_1,@common
DATA_PKT_SET_ADDRESS_1:
	.byte	0x04, 0x08, 0x04, 0x08, 0x04, 0x08, 0x04, 0x04	// KJKJKJKK 00000001 Sync
	.byte	0x04, 0x04, 0x08, 0x04, 0x08, 0x04, 0x04, 0x04	// KKJKJKKK 11000011 DATA0
	.byte	0x08, 0x04, 0x08, 0x04, 0x08, 0x04, 0x08, 0x04	// JKJKJKJK 00000000 0 Out Std Device
	.byte	0x04, 0x08, 0x08, 0x04, 0x08, 0x04, 0x08, 0x04	// KJJKJKJK 10100000 5 Set Address
	.byte	0x04, 0x08, 0x04, 0x08, 0x04, 0x08, 0x04, 0x08	// KJKJKJKJ 10000000 1 wValueL = Addr
	.byte	0x04, 0x08, 0x04, 0x08, 0x04, 0x08, 0x04, 0x08	// KJKJKJKJ 00000000 0 wValueH
	.byte	0x04, 0x08, 0x04, 0x08, 0x04, 0x08, 0x04, 0x08	// KJKJKJKJ 00000000 0
	.byte	0x04, 0x08, 0x04, 0x08, 0x04, 0x08, 0x04, 0x08	// KJKJKJKJ 00000000
	.byte	0x04, 0x08, 0x04, 0x08, 0x04, 0x08, 0x04, 0x08	// KJKJKJKJ 00000000
	.byte	0x04, 0x08, 0x04, 0x08, 0x04, 0x08, 0x04, 0x08  // KJKJKJKJ 00000000
	.byte	0x08, 0x08, 0x04, 0x04, 0x08, 0x08, 0x08, 0x08  // JJKKJJJJ 11010111
	.byte	0x08, 0x04, 0x04, 0x08, 0x04, 0x04, 0x08, 0x04	// JKKJKKJK 10100101 CRC16
	.byte	0x02, 0x02, 0x08, 0x08				// 00JJ			EOP
.type DATA_PKT_DATA_IN_0_0,@common
DATA_PKT_DATA_IN_0_0:
	.byte	0x04, 0x08, 0x04, 0x08, 0x04, 0x08, 0x04, 0x04
	.byte	0x04, 0x08, 0x04, 0x04, 0x08, 0x08, 0x08, 0x04
	.byte	0x08, 0x04, 0x08, 0x04, 0x08, 0x04, 0x08, 0x04
	.byte	0x08, 0x04, 0x08, 0x04, 0x04, 0x08, 0x04, 0x08
	.byte	0x02, 0x02, 0x08, 0x08
.type DATA_PKT_SETUP_TOKEN_1,@common
DATA_PKT_SETUP_TOKEN_1:
	.byte	0x04, 0x08, 0x04, 0x08, 0x04, 0x08, 0x04, 0x04
	.byte	0x04, 0x08, 0x08, 0x08, 0x04, 0x04, 0x08, 0x04
	.byte	0x04, 0x08, 0x04, 0x08, 0x04, 0x08, 0x04, 0x08
	.byte	0x04, 0x08, 0x04, 0x04, 0x08, 0x08, 0x08, 0x08
	.byte	0x02, 0x02, 0x08, 0x08

	.org	0x100
.type DATA_PKT_SET_CONFIGURATION_1,@common
DATA_PKT_SET_CONFIGURATION_1:
	.byte	0x04, 0x08, 0x04, 0x08, 0x04, 0x08, 0x04, 0x04
	.byte	0x04, 0x04, 0x08, 0x04, 0x08, 0x04, 0x04, 0x04
	.byte	0x08, 0x04, 0x08, 0x04, 0x08, 0x04, 0x08, 0x04
	.byte	0x04, 0x08, 0x04, 0x04, 0x08, 0x04, 0x08, 0x04
	.byte	0x04, 0x08, 0x04, 0x08, 0x04, 0x08, 0x04, 0x08
	.byte	0x04, 0x08, 0x04, 0x08, 0x04, 0x08, 0x04, 0x08
	.byte	0x04, 0x08, 0x04, 0x08, 0x04, 0x08, 0x04, 0x08
	.byte	0x04, 0x08, 0x04, 0x08, 0x04, 0x08, 0x04, 0x08
	.byte	0x04, 0x08, 0x04, 0x08, 0x04, 0x08, 0x04, 0x08
	.byte	0x04, 0x08, 0x04, 0x08, 0x04, 0x08, 0x04, 0x08
	.byte	0x08, 0x08, 0x08, 0x04, 0x08, 0x08, 0x04, 0x08
	.byte	0x08, 0x04, 0x04, 0x08, 0x04, 0x04, 0x08, 0x04
	.byte	0x02, 0x02, 0x08, 0x08
.type DATA_PKT_DATA_IN_1_0,@common
DATA_PKT_DATA_IN_1_0:
	.byte	0x04, 0x08, 0x04, 0x08, 0x04, 0x08, 0x04, 0x04
	.byte	0x04, 0x08, 0x04, 0x04, 0x08, 0x08, 0x08, 0x04
	.byte	0x04, 0x08, 0x04, 0x08, 0x04, 0x08, 0x04, 0x08
	.byte	0x04, 0x08, 0x04, 0x04, 0x08, 0x08, 0x08, 0x08
	.byte	0x02, 0x02, 0x08, 0x08
.type DATA_PKT_DATA_IN_1_1,@common
DATA_PKT_DATA_IN_1_1:
	.byte	0x04, 0x08, 0x04, 0x08, 0x04, 0x08, 0x04, 0x04
	.byte	0x04, 0x08, 0x04, 0x04, 0x08, 0x08, 0x08, 0x04
	.byte	0x04, 0x08, 0x04, 0x08, 0x04, 0x08, 0x04, 0x04
	.byte	0x08, 0x04, 0x08, 0x08, 0x08, 0x04, 0x04, 0x08
	.byte	0x02, 0x02, 0x08, 0x08
// nirgendwo ist Bitstuffing erforderlich!
.type DATA_USAGE_ID_TABLE,@common
DATA_USAGE_ID_TABLE:
	.byte	0x00, 0x00, 0x00, 0x00, 'a',  'b',  'c',  'd'
	.byte	'e',  'f',  'g',  'h',  'i',  'j',  'k',  'l'
	.byte	'm',  'n',  'o',  'p',  'q',  'r',  's',  't'
	.byte	'u',  'v',  'w',  'x',  'y',  'z',  '1',  '2'
	.byte	'3',  '4',  '5',  '6',  '7',  '8',  '9',  '0'
	.byte	0x0D, 0x1B, 0x7F, 0x17, ' ',  '-',  '^',  '@'
	.byte	'[',  0x5C, ']',  0x3B, ':',  0x00, 0x2C, '.'
	.byte	'/',  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
.type DATA_BPS,@common
DATA_BPS:
	.byte		0x9B		; PB4-PB2 000   4800bps
	.byte		0x4D		;         001   9600bps
	.byte		0x33		;         010  14400bps
	.byte		0x26		;         011  19200bps
	.byte		0x19		;         100  28800bps 
	.byte		0x13		;         101  38400bps
	.byte		0x0C		;         110  57600bps
	.byte		0x06		;         111 115200bps
	.org	0x200
.type DATA_USAGE_ID_TABLE_SHIFT,@common
DATA_USAGE_ID_TABLE_SHIFT:
	.byte	0x00, 0x00, 0x00, 0x00, 'A',  'B',  'C',  'D'
	.byte	'E',  'F',  'G',  'H',  'I',  'J',  'K',  'L'
	.byte	'M',  'N',  'O',  'P',  'Q',  'R',  'S',  'T'
	.byte	'U',  'V',  'W',  'X',  'Y',  'Z',  '!',  0x22
	.byte	0x23, '$',  '%',  '&',  0x27, '(',  ')',  0x00
	.byte	0x0D, 0x1B, 0x7F, 0x17, ' ',  '=',  '~',  0x60
	.byte	'{',  '|',  '}',  '+',  '*',  0x00, '<',  '>'
	.byte	'?',  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00

;------------------------------------------------------------------------------

main:	clr	r1
	; **** Initialize Stack Pointer ****
	ldi	r24,lo8(RAMEND)	; Stack Pointer Setup
	out	SPL,r24			; Stack Pointer lo8 Byte	
	; **** Turn off Watchdog timer ****
;	ldi	r24,0x18
;	out	WDTCR,r24
;	ldi	r24,0x10
;	out	WDTCR,r24
	; **** Initialize Comparator ****
	sbi	ACSR,7			; Disable comparator to save power
	; **** Initialize I/O Port ****
	sbi	DDRB,0		; LED pin to output
	ldi	r24,0x1E	; Pullups active, LED ON
	out	PORTB,r24
	sbi	DDRD,1		; TxD as output
	; **** Initialize UART ****
	ldiz	DATA_BPS			; Set Baud Rate
	in	r24, PINB
	lsr	r24
	lsr	r24
	andi	r24,7
	add	ZL,r24
	lpm
	out	UBRR,r0		; UART Baud rate generator
	ldi	r24,0x18	; UART Interrupt Disables
	out	UCR,r24		; RX Enable, TX Enable, 9-Bit Disable
	; **** Initialize Timer 0 ****
	ldi	r24,0x02	; Enable Timer0 Overflow Interrupt
	out	TIMSK,r24
	ldi	r24,-F_CPU/1000/64; 1ms Timer Count: Simulate CTC mode (expression = -187 = 0x45 = 69)
	mov	r3,r24
	out	TCNT0,r3
	ldi	r24,0x03	; CK/64, Timer Start
	out	TCCR0,r24
	sei			; Enable Global Interrupt
	; **** Initialize Register ****
	clr	r1
	clr	connect			; Set State Disconnect
	clr	icount
	clr	uartri
	clr	uartwi
	clr	keynum
	; **** Power On Wait ****
	ldi	WL, 10			; 1sec wait
	rcall	DELAY_100MS
	sbi	PORTB,0		; LED OFF
	
	; **** Main Loop ****
MAIN_LOOP:
	ldi	WL, 1				; 1ms wait
	rcall	delay_ms
	cpi	connect, 0			; Check State
	breq	MAIN_LOOP_DISCONNECT
	rjmp	MAIN_CONNECT
MAIN_LOOP_DISCONNECT:
	rjmp	MAIN_DISCONNECT

;------------------------------------------------------------------------------

MAIN_CONNECT:
	; **** Check Disconnection ****
	sbis	PIND, 3
	 rjmp	MAIN_DISCONNECTING
	
	; **** Send EOP ****
	ldiz	DATA_EOP
	ldi	WL, 4
	rcall	usbSendRom
	; **** Interval Count ****
	inc	icount
	cpi	icount, INTERVAL
	brne	MAIN_SEND_PROCESS
	clr	icount
	sbi	PORTB,0				; LED OFF
	
	; **** Interrupt Transfer ****
	ldiz	DATA_PKT_DATA_IN_1_1
	ldi	WL, 36
	rcall	usbSendRom
	rcall	usbRecv
	mov	tmp2, WL
	lds	r0,USBBUFSTART+8	; Check DATA0/1 or NAK/STALL
	sbrc	r0,3
	 rjmp	MAIN_LOOP
	ldiz	DATA_PKT_ACK
	ldi	WL, 20
	rcall	usbSendRom
MAIN_PROCESS:
	; *** Processing Received Data ****
	mov	WL, tmp2
	rcall	USB_CONV
	sbrs	PINB,1
	 rjmp	MAIN_MOUSE_PROCESS
	rjmp	MAIN_KEY_PROCESS

MAIN_SEND_PROCESS:
	rcall	pollUartSend
	rjmp	MAIN_LOOP

MAIN_KEY_PROCESS:
	ldi	keynum_n, 0
	ldiy	USBBUFSTART+2
	ld	keysts, y+
	ld	WL, y+
	tst	WL
	brne	9f
	ld	WL, y+
	tst	WL
	breq	9f
	cbi	PORTB,0		; LED ON
	cpi	keynum, 1
	brcc	2f
	rcall	SND_KEY_DATA
	ldi	keynum_n, 1
2:	ld	WL, y+
	tst	WL
	breq	9f
	cpi	keynum, 2
	brcc	3f
	rcall	SND_KEY_DATA
	ldi	keynum_n, 2
3:	ld	WL, y
	tst	WL
	breq	9f
	cpi	keynum, 3
	brcc	9f
	rcall	SND_KEY_DATA
	ldi	keynum_n, 3
9:	mov	keynum, keynum_n
	rjmp	MAIN_LOOP

MAIN_MOUSE_PROCESS:
	ldiy	USBBUFSTART+2
	ld	WL, y+
	rcall	putchar
	ld	WL, y+
	rcall	putchar
	ld	WL, y
	rcall	putchar
	rjmp	MAIN_LOOP

;------------------------------------------------------------------------------

MAIN_DISCONNECTING:
	; **** 500ms Wait ****
	cbi	PORTB,0			; LED ON
	ldi	WL, 5			; 500ms wait
	rcall	DELAY_100MS
	sbi	PORTB,0			; LED OFF
	; **** Recheck Disconnection ****
	sbis	PIND, 3
	 ldi	connect, 0			; Set State Disconnect
	rjmp	MAIN_LOOP

;------------------------------------------------------------------------------

MAIN_DISCONNECT:
	; **** Check Connection ****
	sbis	PIND, 3
	 rjmp	MAIN_LOOP
MAIN_CONNECTING:
	; **** 500ms Wait ****
	cbi	PORTB,0			; LED ON
	ldi	WL, 5			; 500ms wait
	rcall	DELAY_100MS
	sbi	PORTB,0			; LED OFF
	; **** Recheck Connection ****
	sbis	PIND, 3
	 rjmp	MAIN_LOOP
	cbi	PORTB,0			; LED ON
	
	; **** USB Reset ****
	ldi	WL, 200			; 200ms wait
	rcall	delay_ms
	sbi	DDRD,2		; drive SE0 = LL = start Bus Reset
	sbi	DDRD,3		// PORTD bits are constantly held to 0
	ldi	WL, 10	; 10ms wait
	rcall	delay_ms
	rcall	usbEndOfTx
	
	; **** 40ms Loop ****
	ldi	tmp1, 40
MAIN_CONNECTING_AFTER_RESET:
	push	tmp1
	ldi	WL, 1		;1ms Wait
	rcall	delay_ms
	; **** Send EOP ****
	ldiz	DATA_EOP
	ldi	WL, 4
	rcall	usbSendRom
	pop	tmp1
	dec	tmp1
	brne	MAIN_CONNECTING_AFTER_RESET
	
	; **** Set Address ****
	ldiz	DATA_PKT_SETUP_TOKEN_0
	ldi	WL, 36
	rcall	usbSendRom
	ldiz	DATA_PKT_SET_ADDRESS_1
	ldi	WL, 100
	rcall	usbSendRom
	rcall	usbRecv
MAIN_CONNECTING_SET_ADDRESS:
	ldiz	DATA_PKT_DATA_IN_0_0
	ldi	WL, 36
	rcall	usbSendRom
	rcall	usbRecv
	lds	r0,USBBUFSTART+8	; Check DATA0/1 or NAK/STALL
	sbrc	r0,3
	 rjmp	MAIN_CONNECTING_SET_ADDRESS
	ldiz	DATA_PKT_ACK
	ldi	WL, 20
	rcall	usbSendRom

	; **** Send EOP ****
	ldi	WL, 1
	rcall	delay_ms
	ldiz	DATA_EOP
	ldi	WL, 4
	rcall	usbSendRom

	; **** Set Configuration ****
	ldiz	DATA_PKT_SETUP_TOKEN_1
	ldi	WL, 36
	rcall	usbSendRom
	ldiz	DATA_PKT_SET_CONFIGURATION_1
	ldi	WL, 100
	rcall	usbSendRom
	rcall	usbRecv
MAIN_CONNECTING_SET_CONFIG:
	ldiz	DATA_PKT_DATA_IN_1_0
	ldi	WL, 36
	rcall	usbSendRom
	rcall	usbRecv
	lds	r0,USBBUFSTART+8	; Check DATA0/1 or NAK/STALL
	sbrc	r0,3
	 rjmp	MAIN_CONNECTING_SET_CONFIG
	ldiz	DATA_PKT_ACK
	ldi	WL, 20
	rcall	usbSendRom
	
	; **** Finish Connecting ****
	sbi	PORTB,0		; LED OFF
	ldi	connect, 1			; Set State Connect

	rjmp	MAIN_LOOP

;------------------------------------------------------------------------------
;------------------------------------------------------------------------------

; parameter	Z ... send data address, must not straddle page boundary!
;           WL  ... send data length
; return	none
; crash		WL, tmp1, ZH, ZL, r0

usbSendRom:
	cli
	sbi	PORTD,3
	sbi	DDRD,2
	sbi	DDRD,3		; drive J state = HL on (D-,D+)
// time-critical loop! 8 clock ticks per bit!
// Cumbersome, may affect other port pins
1:	lpm		;[3]
	inc	ZL	;[4]
	out	PORTD,r0;[5]
	dec	WL	;[6]
	brne	1b	;[8]
// Ends in J state by ROM data
usbEndOfTx:
	cbi	DDRD,2	; Set PD2 and PD3 to high-impedance state
	cbi	DDRD,3
	cbi	PORTD,2
	cbi	PORTD,3
	reti
// Bus should now be in J state by device-side pullup,
// and device will start to send answer, except for SOF = EOP only.
// SE0 = disconnection event, K = device activity, SE1 = device failure.

;------------------------------------------------------------------------------

; parameter	none
; return    WL  ... received data length
; crash		WL, tmp1, ZH, ZL

usbRecv:
	ldiz	USBBUFSTART
	ldi	tmp1, 100
// time-critical loop
	cli
1:	sbic	PIND,3			; Wait until PD3(D-) == 0 == K state
	 rjmp	1b
2:	in	WL, PIND	;[1]
	st	z+, WL		;[3]
	andi	WL, 0x0C	;[4]	check for EOP = SE0
	breq	3f		;[5]	bail out on SE0
	dec	tmp1		;[6]
	brne	2b		;[8]
3:	sbis	PIND, 3		; Wait until PD3(D-) == 1
	 rjmp	3b		;    [9]
	ldi	WL,100
	sub	WL,tmp1	// return data bits received
	reti
// Normally, first 8 bytes of USBBUFSTART will contain sync bits.
// Then, the PID token follows.

;------------------------------------------------------------------------------

; parameter	WL  ... convert data length
; return	none
; crash		WL, tmp1, tmp2. ZH, ZL

USB_CONV:
	rcall	USB_CONV_NRZI
	rjmp	USB_CONV_BYTE

;------------------------------------------------------------------------------

; parameter	WL  ... convert data length
; return	none
; crash		WL, tmp1, tmp2, ZH, ZL

USB_CONV_NRZI:
	ldiz	USBBUFSTART
	ldi	tmp1, 0x0B
1:	ld	tmp2, z
	cp	tmp1, tmp2
	brne	3f
	ldi	tmp2, 1
	rjmp	4f
3:	mov	tmp1, tmp2
	ldi	tmp2, 0
4:	st	z+, tmp2
	dec	WL
	brne	1b
	ldi	tmp1, 0xFF			; Set End Mark
	st	z, tmp1
	ret

;------------------------------------------------------------------------------

; parameter	none
; return	none
; crash		WL, WH, tmp1, tmp2, YH, YL, ZH, ZL

USB_CONV_BYTE:
	ldiz	USBBUFSTART
	mov	YL,ZL
	mov	YH,ZH
	ldi	tmp1, 0				; clear bit stuff count
1:	ldi	tmp2, 0				; clear data
	ldi	WL, 8
2:	ld	WH, y+
	cpi	WH, 0xFF
	breq	5f
	ror	WH
	ror	tmp2
	sbrs	tmp2, 7
	 rjmp	3f
	inc	tmp1
	cpi	tmp1, 6
	brne	4f
	adiw	YL, 1
3:	ldi	tmp1, 0
4:	dec	WL
	brne	2b
	st	z+, tmp2
	rjmp	1b
5:	st	z, WH
	ret

;------------------------------------------------------------------------------
#if 0
putHexWord:	// parameter	ZH:ZL ... value to put
	mov	WL, ZH
	rcall	putHexByte
	mov	WL, ZL
putHexByte:	// parameter	WL ... value to put
	push	WL
	swap	WL
	rcall	putHexNibble
	pop	WL
putHexNibble:
	andi	WL, 0x0F
putDigit:	// parameter	WL ... value to put (max. 35)
	subi	WL,-'0'
	cpi	WL,'0'+10
	brcs	putchar
	subi	WL,-7
#endif

; parameter	WL ... character to send
; crash		XH, XL
putchar:
	ldix	UARTBUF
	add	XL, uartwi
	st	x, WL
	inc	uartwi
	sbrc	uartwi,3	// reached 8?
	 clr	uartwi
0:	cpse	uartri,uartwi
	 ret
	rcall	pollUartSend2
	rjmp	0b

;------------------------------------------------------------------------------
	

; parameter	WL ... delay time (ms)
; return	none
; crash		WL

delay_ms:
	mov	r0,tcount
0:	mov	WH,tcount
	sub	WH,r0
	cp	WH,WL
	brcs	0b
	ret

;------------------------------------------------------------------------------

; parameter	WL ... delay time (100ms)
; return	none
; crash		WL, tmp1, tmp2

DELAY_100MS:
	push	WL
	ldi	WL, 100
	rcall	delay_ms
	pop	WL
	dec	WL
	brne	DELAY_100MS
	ret

;------------------------------------------------------------------------------

; parameter	none
; return	WL ... value from buffer
;			carry .. 0:valid value  1:buffer empty
; crash		WL, XH, XL

pollUartSend:
	cpse	uartri,uartwi	// ring buffer empty?
	 rjmp	9f		// yes, do nothing
pollUartSend2:			// entry for uartri==uartwi when completely full
	sbis	USR,5		// UART TX ready to accept byte?
	 ret			// no, do nothing
	ldix	UARTBUF
	add	XL,uartri
	ld	r0,x
	out	UDR,r0
	inc	uartri
	sbrc	uartri,3	// reached 8?
	 clr	uartri
9:	ret

;------------------------------------------------------------------------------

; parameter	WL ... value of key data
; return	zero ... 0:send  1:none
; crash		WL, tmp1, ZH, ZL

SND_KEY_DATA:
	mov	tmp1, keysts
	andi	tmp1, 0x22
	brne	2f
	ldiz	DATA_USAGE_ID_TABLE
	rjmp	3f
2:	ldiz	DATA_USAGE_ID_TABLE_SHIFT
3:	add	ZL, WL
	lpm
	tst	r0
	breq	9f
	mov	WL, r0
	rcall	putchar
	tst	WL
9:	ret
